Page MenuHomePhabricator

CX2: Adjust missing links
Closed, ResolvedPublic

Description

Currently links that cannot be adapted are shown as regular links:

For links that cannot be adapted (i.e., because there is no equivalent link on the target wiki), we want users to decide whether to create a red link for them. In order to support this, these links are shown in grey with an option to turn them into red links.
The cards shown are aligned with T168290 :

Unadapted links

  • The link card is labelled as "missing link"
  • An option is provided to remove the grey link, turning it into regular text.
  • A "mark as missing" option allows to create a red link (see below for more details).

Red links

  • Red links, coming from an unadapted link or created by the user will provide the usual controls to remove or edit the link.
  • The page title shown in red, will allow to create the new page in a new window:
    • If we know the corresponding source article, clicking on the page name will open the translation dashboard in a new window ready for the user to confirm the new translation dialog.
    • If we don't know the corresponding page on the original article, the link will open the missing page on a new window.
  • At the bottom, the corresponding source page is shown (if we know the corresponding source page)

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptApr 27 2018, 12:01 PM
santhosh updated the task description. (Show Details)May 3 2018, 6:40 AM

Change 430357 had a related patch set uploaded (by Santhosh; owner: Santhosh):
[mediawiki/extensions/ContentTranslation@master] WIP: CX2: Adjust the design for link cards

https://gerrit.wikimedia.org/r/430357

Arrbee assigned this task to santhosh.May 3 2018, 8:01 AM

Change 430357 merged by jenkins-bot:
[mediawiki/extensions/ContentTranslation@master] CX2: Adjust the design for link cards - Part 1

https://gerrit.wikimedia.org/r/430357

Nikerabbit added a subscriber: Nikerabbit.

I am not moving to QA yet because "Mark as missing" is not implemented yet.

Change 435962 had a related patch set uploaded (by Santhosh; owner: Santhosh):
[mediawiki/extensions/ContentTranslation@master] CX2: Adjust missing links

https://gerrit.wikimedia.org/r/435962

I'm making comments about 435962 here, to make it more visible for @Pginer-WMF.

Without the patch, non-adapted links are displayed gray and clicking on links opens link card with "Mark as missing" option. With the patch, non-adapted links are still gray and clicking "Mark as missing" turns gray into red. Here is how the card looks:


Also, for English to Spanish translation, clicking "Mark as missing" turns non-adapted link that corresponds to "Free people" on enwiki and has translated link text of "Personas Libres" into this card.

Now, the previously non-adapted link, with text "Personas Libres" was marked as missing, gray link turned red in target column. By clicking on red link, we see that "Personas Libres" translation (coming from MT) is lost and missing link points to "Free people". Everything in above card works as expected: red link opens CX, source link opens page in new tab and link removal works.

When such page is published, new page has non-adapted links (which aren't "marked as missing") displayed in red, just as link which is "marked as missing". The only thing we get with this functionality is that red link in published page, with text "Personas Libres" now points to the creation of "Free people" page in a Spanish wiki.

I think the point of the patch was to add the ability to mark pieces of text, which aren't links yet, as missing links in a published page. We don't have that yet in current patch set. I think non-adapted links should be displayed as red initially, with the above card appearing on click.

Another thing that we need to work on: No action on links is triggering the autosave.

When such page is published, new page has non-adapted links (which aren't "marked as missing") displayed in red, just as link which is "marked as missing". The only thing we get with this functionality is that red link in published page, with text "Personas Libres" now points to the creation of "Free people" page in a Spanish wiki.

Non-adapted (grey) links should be published as regular text. I captured the details for the missing functionality in T197579 based on the issues reported by a translator.

Where the red link should be pointing to, is another aspect worth discussing. Currently it seems that the title of the article in the source wiki is used for the red link as a link target. This results in the red link suggesting the creation of an article as it is titled in the source language. I think the best approach is to first check if the Wikidata item has a title for the item in the target language (even if the article does not exist in Wikipedia for that language, titles can be translated), and use it as the target for the red link. If that is not available, use the red link label as the target. In both of these cases it may be the case that an article in the target wiki happens to have the same title we selected (despite not being connected through Wikidata), and we need to define what to do. I'll capture these aspects in a separate ticket.

I think non-adapted links should be displayed as red initially, with the above card appearing on click.

Depending on the wiki coverage it may be preferred to have red links created automatically or not. For small wikis, having your initial translation full of red links can be overwhelming. We decided to mark the missing links in grey for users to make a choice on which ones are worth marking as missing. In this way you can decide based on the dynamics of your wiki. There may be cases where you want to mark all as missing, which is something we'll explore in T197455.

I'll capture these aspects in a separate ticket.

I created a separate ticket to find the right target for a missing link and what to do if such target collides with another existing article: T197787: CX2: Apply the right target when creating a missing link

I'd recommend going through it with a fresh brain since it involves different concept interconnections. I tried to describe it as clearly as I could, but feel free to ask for any clarifications if needed.

Change 435962 merged by Nikerabbit:
[mediawiki/extensions/ContentTranslation@master] CX2: Add feature to mark unadapted link as red link

https://gerrit.wikimedia.org/r/435962

Petar.petkovic moved this task from In Review to QA on the Language-2018-Apr-June board.
Petar.petkovic removed a subscriber: gerritbot.
Etonkovidova closed this task as Resolved.Jun 29 2018, 1:32 AM
Etonkovidova added a subscriber: Etonkovidova.

Checked in cx2-testing - all works according to the specs in the tasks. Grey links and links that marked as missing will be published as red links. I think that it makes sense to have red links on ContentTranslation page only after a user marks them as missing.

Vvjjkkii renamed this task from CX2: Adjust missing links to q3daaaaaaa.Jul 1 2018, 1:13 AM
Vvjjkkii reopened this task as Open.
Vvjjkkii removed santhosh as the assignee of this task.
Vvjjkkii raised the priority of this task from Normal to High.
Vvjjkkii updated the task description. (Show Details)
Vvjjkkii edited subscribers, added: santhosh; removed: Aklapper.
CommunityTechBot renamed this task from q3daaaaaaa to CX2: Adjust missing links.Jul 2 2018, 3:03 PM
CommunityTechBot closed this task as Resolved.
CommunityTechBot assigned this task to santhosh.
CommunityTechBot lowered the priority of this task from High to Normal.
CommunityTechBot updated the task description. (Show Details)
CommunityTechBot edited subscribers, added: Aklapper; removed: santhosh.